=== debian/changelog ===
hashcat (3.30-1) unstable; urgency=medium

  [ Samuel Henrique ]
  * Team upload.
  * New upstream version 3.30.
  * wrap-and-sort -a.
  * d/rules: Remove trailing whitespace.
  * d/copyright: Update copyright.
  * d/patches:
    - add_kfreebsd_support.diff: Update and Refresh.
    - fix_makefile.patch: Refresh.

  [ Lorenzo "Palinuro" Faletra ]
  * Include libhashcat.so in hashcat binary package.

  [ Raphaël Hertzog ]
  * Install libhashcat.so in /usr/lib/hashcat. It's not clean enough
    to be supported as a public library.
  * Drop -march=native from the Makefile. Closes: #851497

 -- Raphaël Hertzog <hertzog@debian.org>  Thu, 19 Jan 2017 18:00:19 +0100
