=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%hashcat-$1.tar.gz%" \
  https://github.com/hashcat/hashcat/tags \
  (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
