## hashcat 3.60

=== debian/changelog ===
hashcat (3.60-1) unstable; urgency=medium

  * Team upload.

  [ Sophie Brun ]
  * debian/control: drop depends on mesa-opencl-icd as it's not compatible
    with beignet-opencl-icd and replace it with pocl-opencl-icd. Add all
    relevant *-opencl-icd in Suggests as a hint that the user should install
    the appropriate package for its hardware.

  [ Paul Wise ]
  * Fix apostrophe in description

  [ philipp ]
  * Fix package description (Closes: #855687)
  * Make URLS in https mode.

  [ Raphaël Hertzog ]
  * New upstream release.
  * Updated watch file to work around broken versioning scheme
    (https://github.com/hashcat/hashcat/issues/1275).
  * Update patches (reuse work made in Kali).
  * Update copyright file.
  * Stop installing libhashcat.so. It's not used by the hashcat binary and has
    no stable API.

 -- Raphaël Hertzog <hertzog@debian.org>  Thu, 15 Jun 2017 17:21:21 +0200
