=== debian/control ===
--- 
+++ 
@@ -7,20 +7,21 @@
                libgmp-dev,
                opencl-headers
 Standards-Version: 3.9.8
-Homepage: http://hashcat.net/hashcat/
+Homepage: https://hashcat.net/hashcat/
 Vcs-Git: https://anonscm.debian.org/git/pkg-security/hashcat.git
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-security/hashcat.git
 
 Package: hashcat
 Architecture: kfreebsd-any amd64 i386
 Depends: hashcat-data (>= ${source:Version}),
-         mesa-opencl-icd | opencl-icd,
+         pocl-opencl-icd | opencl-icd,
          ${misc:Depends},
          ${shlibs:Depends}
+Suggests: beignet-opencl-icd, nvidia-opencl-icd, mesa-opencl-icd
 Description: World's fastest and most advanced password recovery utility
- Hashcat supports five unique modes of attack for over 160 highly-optimized
- hashing algorithms. hashcat currently supports CPU's, GPU's other
- hardware-accelerators on Linux, and has facilities to help enable
+ Hashcat supports five unique modes of attack for over 200 highly-optimized
+ hashing algorithms. hashcat currently supports CPUs, GPUs, and other
+ hardware accelerators on Linux, and has facilities to help enable
  distributed password cracking.
  .
  Examples of hashcat supported hashing algorithms are:
