=== debian/control ===
--- 
+++ 
@@ -6,10 +6,10 @@
 Build-Depends: debhelper (>=10),
                libgmp-dev,
                opencl-headers
-Standards-Version: 3.9.8
+Standards-Version: 4.1.3
 Homepage: https://hashcat.net/hashcat/
-Vcs-Git: https://anonscm.debian.org/git/pkg-security/hashcat.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-security/hashcat.git
+Vcs-Git: https://salsa.debian.org/pkg-security-team/hashcat.git
+Vcs-Browser: https://salsa.debian.org/pkg-security-team/hashcat
 
 Package: hashcat
 Architecture: kfreebsd-any amd64 i386
@@ -65,6 +65,7 @@
 
 Package: hashcat-data
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Suggests: hashcat
 Replaces: hashcat (<= 2.00-0kali3)
