=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,7 @@
 	dh $@
 
 override_dh_auto_build:
-	dh_auto_build -- PREFIX=/usr DEBUG=1 LIBRARY_FOLDER=/usr/lib/hashcat COMPTIME=$(SOURCE_DATE_EPOCH)
+	dh_auto_build -- PREFIX=/usr DEBUG=1 COMPTIME=$(SOURCE_DATE_EPOCH)
 
 override_dh_installchangelogs:
 	dh_installchangelogs docs/changes.txt
