=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%hashcat-$1.tar.gz%,uversionmangle=s/^3.(5|6).0/3.${1}0/" \
  https://github.com/hashcat/hashcat/tags \
  (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
